/**************************************************************************

	nLaunch

	option.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>

#include "file.h"
#include "image.h"
#include "ini.h"
#include "option.h"

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE				256							/* obt@TCY */

#define MOVE_MAXSIZE			1000						/* ړx̍őTCY */
#define MOVE_SETMAXSIZE			61							/* ݒ̈ړx̍őTCY */
#define MOVE_PAGESIZE			5							/* ݒ̈ړ̃y[WTCY */

#define LAYERER_SETMAXSIZE		255
#define LAYERER_PAGESIZE		17

#define FILTER_SELECT			"I"
#define FILTER_EXCEPTION		"O"

#define WM_GETOPTION			(WM_APP + 1)
#define WM_SETOPTION			(WM_APP + 2)
#define WM_GETCOLOR				(WM_APP + 3)
#define WM_SETCOLOR				(WM_APP + 4)
#define WM_ENABLESWITCH			(WM_APP + 5)

#define ID_DRAW_TIMER			1
#define DRAW_INTERVAL			200

#define PREVIEW_LEFT			8
#define PREVIEW_TOP				8


/**************************************************************************
	Global Variables
**************************************************************************/

static PAINTINFO *MainPaintInfo;
static BOOL PropRet;

extern HINSTANCE hInst;
extern char app_path[BUF_SIZE];

/* INI */
extern char launch_path[BUF_SIZE];
extern char filterPtn[BUF_SIZE];
extern int filterType;
extern int ShowDir;

extern int ShowModKey;
extern char ShowVKey;
extern int BackModKey;
extern char BackVKey;

extern int MoveTop;
extern int UseMouse;

extern int MoveSpeed;

extern int Layerer;
extern int LayererAlpha;

/* struct */
typedef struct _FONTINFO {
	char FontName[BUF_SIZE];		/* tHg */
	char FontStyle[BUF_SIZE];		/* tHgX^C */
	int FontItalic;					/* Α */
	int FontHeight;					/* tHg̍ */
	int FontWeight;					/* tHg̑ */
} FONTINFO;


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static long GetColor(const HWND hWnd, long color);
static BOOL GetFontInfo(const HWND hWnd, FONTINFO *FontInfo);
static LRESULT OptionNotifyProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
static BOOL CALLBACK SetOptionProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
static BOOL CALLBACK GetRegistProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
static BOOL CALLBACK SetWindowOptionProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);


/******************************************************************************

	GetColor

	F̑I

******************************************************************************/

static long GetColor(const HWND hWnd, long color)
{
	CHOOSECOLOR ch;
	static DWORD ColorTbl[16];

	ZeroMemory(&ch, sizeof(CHOOSECOLOR));
	ch.lStructSize = sizeof(CHOOSECOLOR);
	ch.hwndOwner = hWnd;
	ch.rgbResult = color;
	ch.lpCustColors = ColorTbl;
	ch.Flags = CC_RGBINIT | CC_FULLOPEN;
	/* F̑I */
	if(ChooseColor(&ch) == TRUE){
		return ch.rgbResult;
	}
	return color;
}


/******************************************************************************

	GetFontInfo

	tHg̑I

******************************************************************************/

static BOOL GetFontInfo(const HWND hWnd, FONTINFO *FontInfo)
{
	CHOOSEFONT cf;
	LOGFONT LogFont;
	HDC hdc;
	char buf[BUF_SIZE];

	/* tHg̍쐬 */
	ZeroMemory(&LogFont, sizeof(LOGFONT));
	hdc = GetDC(NULL);
	LogFont.lfHeight = -(int)((FontInfo->FontHeight * GetDeviceCaps(hdc, LOGPIXELSY)) / 72);
	ReleaseDC(NULL, hdc);
	LogFont.lfWeight = FontInfo->FontWeight;
	LogFont.lfItalic = FontInfo->FontItalic;
	LogFont.lfCharSet = DEFAULT_CHARSET;
	lstrcpy(LogFont.lfFaceName, FontInfo->FontName);
	lstrcpy(buf, FontInfo->FontStyle);

	/* tHgIp\̂̏ */
	ZeroMemory(&cf, sizeof(CHOOSEFONT));
	cf.lStructSize = sizeof(CHOOSEFONT);
	cf.hwndOwner = hWnd;
	cf.lpLogFont = &LogFont;
	cf.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT | CF_USESTYLE | CF_NOSCRIPTSEL;
	cf.lpszStyle = buf;
	cf.nFontType = SCREEN_FONTTYPE;

	/* tHgI_CAO\ */
	if(ChooseFont(&cf) == FALSE){
		return FALSE;
	}

	/* ݒۑpɏޔ */
	lstrcpy(FontInfo->FontName, LogFont.lfFaceName);
	lstrcpy(FontInfo->FontStyle, cf.lpszStyle);
	FontInfo->FontItalic = LogFont.lfItalic;
	FontInfo->FontHeight = cf.iPointSize / 10;
	FontInfo->FontWeight = LogFont.lfWeight;
	return TRUE;
}


/******************************************************************************

	OptionNotifyProc

	vpeBV[g̃Cxg̒ʒm

******************************************************************************/

static LRESULT OptionNotifyProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	PSHNOTIFY *pshn = (PSHNOTIFY FAR *) lParam;
	NMHDR *lpnmhdr = (NMHDR FAR *)&pshn->hdr;

	switch(lpnmhdr->code)
	{
	case PSN_APPLY:				/* OK */
		PropRet = TRUE;
		SendMessage(hDlg, WM_COMMAND, IDOK, 0);
		break;

	case PSN_QUERYCANCEL:		/* LZ */
		SendMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
		break;
	}
	return PSNRET_NOERROR;
}


/******************************************************************************

	SetLayererProc

	ݒEBhEvV[W

******************************************************************************/

static BOOL CALLBACK SetLayererProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		/* EBhȄ */
		SendDlgItemMessage(hDlg, IDC_CHECK_USE_LAYERER, BM_SETCHECK, Layerer, 0);

		SendDlgItemMessage(hDlg, IDC_SLIDER_ALPHA, TBM_SETRANGE, FALSE, (LPARAM)MAKELONG(1, LAYERER_SETMAXSIZE));
		SendDlgItemMessage(hDlg, IDC_SLIDER_ALPHA, TBM_SETPAGESIZE, 0, (LPARAM)LAYERER_PAGESIZE);
		for(i = 1; i < LAYERER_SETMAXSIZE; i += LAYERER_PAGESIZE){
			SendDlgItemMessage(hDlg, IDC_SLIDER_ALPHA, TBM_SETTIC, 0, (LPARAM)i);
		}
		SendDlgItemMessage(hDlg, IDC_SLIDER_ALPHA, TBM_SETPOS, TRUE, (LPARAM)LayererAlpha);

		EnableWindow(GetDlgItem(hDlg, IDC_SLIDER_ALPHA), Layerer);
		break;

	case WM_CLOSE:
		/* EBhE */
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_CHECK_USE_LAYERER:
			EnableWindow(GetDlgItem(hDlg, IDC_SLIDER_ALPHA),
				SendDlgItemMessage(hDlg, IDC_CHECK_USE_LAYERER, BM_GETCHECK, 0, 0));
			break;

		case IDOK:
			Layerer = SendDlgItemMessage(hDlg, IDC_CHECK_USE_LAYERER, BM_GETCHECK, 0, 0);
			LayererAlpha = SendDlgItemMessage(hDlg, IDC_SLIDER_ALPHA, TBM_GETPOS, 0, 0);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SetOptionProc

	ݒEBhEvV[W

******************************************************************************/

static BOOL CALLBACK SetOptionProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char buf[BUF_SIZE];
	int i;
	BOOL EnableFlag;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		/* tH_̃pX̐ݒ */
		SendDlgItemMessage(hDlg, IDC_EDIT_PATH, WM_SETTEXT, 0, (LPARAM)launch_path);
		SetWindowText(GetDlgItem(hDlg, IDC_BUTTON_FILTERTYPE), ((filterType == 1) ? FILTER_EXCEPTION : FILTER_SELECT));
		SendDlgItemMessage(hDlg, IDC_EDIT_FILTER, WM_SETTEXT, 0, (LPARAM)filterPtn);
		SendDlgItemMessage(hDlg, IDC_CHECK_SHOWDIR, BM_SETCHECK, ShowDir, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_MOVETOP, BM_SETCHECK, MoveTop, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_USEMOUSE, BM_SETCHECK, UseMouse, 0);

		/* zbgL[̐ݒ */
		i = ((ShowModKey & 1) ? 4 : 0) | (ShowModKey & 2) | ((ShowModKey & 4) ? 1 : 0);
		SendDlgItemMessage(hDlg, IDC_HOTKEY_SHOW,
			HKM_SETHOTKEY, (WPARAM)MAKEWORD(ShowVKey, i), 0);

		i = ((BackModKey & 1) ? 4 : 0) | (BackModKey & 2) | ((BackModKey & 4) ? 1 : 0);
		SendDlgItemMessage(hDlg, IDC_HOTKEY_BACK,
			HKM_SETHOTKEY, (WPARAM)MAKEWORD(BackVKey, i), 0);

		/* XN[x̐ݒ */
		SendDlgItemMessage(hDlg, IDC_SLIDER_MOVESPEED, TBM_SETRANGE, FALSE, (LPARAM)MAKELONG(1, MOVE_SETMAXSIZE));
		SendDlgItemMessage(hDlg, IDC_SLIDER_MOVESPEED, TBM_SETPAGESIZE, 0, (LPARAM)MOVE_PAGESIZE);
		for(i = 1; i < MOVE_SETMAXSIZE; i += MOVE_PAGESIZE){
			SendDlgItemMessage(hDlg, IDC_SLIDER_MOVESPEED, TBM_SETTIC, 0, (LPARAM)i);
		}
		if(MoveSpeed > MOVE_MAXSIZE){
			/* Aj[VȂݒ */
			SendDlgItemMessage(hDlg, IDC_SLIDER_MOVESPEED, TBM_SETPOS, TRUE, (LPARAM)MoveSpeed - MOVE_MAXSIZE);
			EnableWindow(GetDlgItem(hDlg, IDC_SLIDER_MOVESPEED), FALSE);
			EnableWindow(GetDlgItem(hDlg, IDC_STATIC_LOW), FALSE);
			EnableWindow(GetDlgItem(hDlg, IDC_STATIC_HIGH), FALSE);
		}else{
			SendDlgItemMessage(hDlg, IDC_SLIDER_MOVESPEED, TBM_SETPOS, TRUE, (LPARAM)MoveSpeed);
			SendDlgItemMessage(hDlg, IDC_CHECK_ANI, BM_SETCHECK, 1, 0);
		}
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, uMsg, wParam, lParam);

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_BUTTON_SELECTPATH:
			/* tH_̑I */
			if(FolderSelect(hDlg, buf) == TRUE){
				SendDlgItemMessage(hDlg, IDC_EDIT_PATH, WM_SETTEXT, 0, (LPARAM)buf);
			}
			break;

		case IDC_BUTTON_FILTERTYPE:
			/* tB^̎ʂ̐؂ւ */
			GetWindowText(GetDlgItem(hDlg, IDC_BUTTON_FILTERTYPE), buf, BUF_SIZE - 1);
			SetWindowText(GetDlgItem(hDlg, IDC_BUTTON_FILTERTYPE),
				((lstrcmp(buf, FILTER_SELECT) == 0) ? FILTER_EXCEPTION : FILTER_SELECT));
			break;

		case IDC_CHECK_ANI:
			/* XC_[̐ݒ */
			EnableFlag = SendDlgItemMessage(hDlg, IDC_CHECK_ANI, BM_GETCHECK, 0, 0);
			EnableWindow(GetDlgItem(hDlg, IDC_SLIDER_MOVESPEED), EnableFlag);
			EnableWindow(GetDlgItem(hDlg, IDC_STATIC_LOW), EnableFlag);
			EnableWindow(GetDlgItem(hDlg, IDC_STATIC_HIGH), EnableFlag);
			break;

		case IDC_BUTTON_LAYERER:
			/* ݒ */
			if(DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_LAYERER), hDlg, SetLayererProc, 0) == FALSE){
				break;
			}
			break;

		case IDOK:
			/* tH_̃pX̎擾 */
			SendDlgItemMessage(hDlg, IDC_EDIT_PATH,
				WM_GETTEXT, BUF_SIZE - 1, (LPARAM)launch_path);
			/* tB^̎擾 */
			GetWindowText(GetDlgItem(hDlg, IDC_BUTTON_FILTERTYPE), buf, BUF_SIZE - 1);
			filterType = (lstrcmp(buf, FILTER_SELECT) == 0) ? 0 : 1;
			SendDlgItemMessage(hDlg, IDC_EDIT_FILTER,
				WM_GETTEXT, BUF_SIZE - 1, (LPARAM)filterPtn);
			ShowDir = SendDlgItemMessage(hDlg, IDC_CHECK_SHOWDIR, BM_GETCHECK, 0, 0);
			MoveTop = SendDlgItemMessage(hDlg, IDC_CHECK_MOVETOP, BM_GETCHECK, 0, 0);
			UseMouse = SendDlgItemMessage(hDlg, IDC_CHECK_USEMOUSE, BM_GETCHECK, 0, 0);

			/* zbgL[̎擾 */
			i = SendDlgItemMessage(hDlg,IDC_HOTKEY_SHOW, HKM_GETHOTKEY, 0, 0);
			ShowVKey = LOBYTE(i);
			i = HIBYTE(i);
			ShowModKey = ((i & 1) ? 4 : 0) | (i & 2) | ((i & 4) ? 1 : 0);

			i = SendDlgItemMessage(hDlg,IDC_HOTKEY_BACK, HKM_GETHOTKEY, 0, 0);
			BackVKey = LOBYTE(i);
			i = HIBYTE(i);
			BackModKey = ((i & 1) ? 4 : 0) | (i & 2) | ((i & 4) ? 1 : 0);

			/* XN[x̎擾 */
			MoveSpeed = SendDlgItemMessage(hDlg, IDC_SLIDER_MOVESPEED, TBM_GETPOS, 0, 0);
			if(SendDlgItemMessage(hDlg, IDC_CHECK_ANI, BM_GETCHECK, 0, 0) == 0){
				/* Aj[VȂݒ̏ꍇ͍őTCYZ */
				MoveSpeed += MOVE_MAXSIZE;
			}
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	GetRegistProc

	o^̓EBhEvV[W

******************************************************************************/

static BOOL CALLBACK GetRegistProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char *buf;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		/* EBhȄ */
		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_SETTEXT, 0, lParam);
		break;

	case WM_CLOSE:
		/* EBhE */
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			buf = (char *)GetWindowLong(hDlg, GWL_USERDATA);
			*buf = '\0';
			SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
			if(*buf == '\0'){
				MessageBox(hDlg, "o^͂Ă܂", "o^", MB_ICONEXCLAMATION);
				break;
			}
			ConvFilename(buf);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SetWindowOptionProc

	\ݒEBhEvV[W

******************************************************************************/

static BOOL CALLBACK SetWindowOptionProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	DRAWITEMSTRUCT *dis;
	HBRUSH hbrush;
	RECT rect;
	HDC hdc;
	HBITMAP hBmp, hrBmp;
	POINT ps;
	static PAINTINFO op;
	PAINTINFO *pi;
	DRAWINFO di;
	static FONTINFO FontInfo;
	static char rname[BUF_SIZE];
	char buf[BUF_SIZE];
	char fname[BUF_SIZE];
	long color;
	int size;
	int mode;
	int i, x, y;
	BOOL EnableFlag;
	BOOL ColorEnable, SizeEnable;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		SendDlgItemMessage(hDlg, IDC_SPIN_SIZE, UDM_SETRANGE, 0, (LPARAM)MAKELONG(300, 0));

		/* o^ς݂̐ݒꗗ\ */
		EnumWindowIni(GetDlgItem(hDlg, IDC_COMBO_SAVEDATA), app_path);

		/* w肷镔̒ǉ */
#define SetCmbItem(ctl, name)		SendDlgItemMessage(hDlg, ctl, CB_ADDSTRING, 0,(LPARAM)name)
		SetCmbItem(IDC_COMBO_COLOR, "EBhE");
		SetCmbItem(IDC_COMBO_COLOR, "EBhE̋E");
		SetCmbItem(IDC_COMBO_COLOR, "EBhE̓F");
		SetCmbItem(IDC_COMBO_COLOR, "ACR");
		SetCmbItem(IDC_COMBO_COLOR, "ACR̕\");
		SetCmbItem(IDC_COMBO_COLOR, "ACR̊Ԋu");
		SetCmbItem(IDC_COMBO_COLOR, "ACR̉ʒu");
		SetCmbItem(IDC_COMBO_COLOR, "ACȐcʒu");
		SetCmbItem(IDC_COMBO_COLOR, "tH[JX");
		SetCmbItem(IDC_COMBO_COLOR, "tH[JX̋E");
		SetCmbItem(IDC_COMBO_COLOR, "^Cgo[");
		SetCmbItem(IDC_COMBO_COLOR, "^Cgo[̃eLXg");
		SetCmbItem(IDC_COMBO_COLOR, "eLXg̍]");
		SetCmbItem(IDC_COMBO_COLOR, "eLXg̉E]");
		SetCmbItem(IDC_COMBO_COLOR, "eLXg̏cʒu");

		/* 摜̈ʒu̒ǉ */
		SetCmbItem(IDC_COMBO_PAINTMODE, "ɕ\");
		SetCmbItem(IDC_COMBO_PAINTMODE, "ׂĕ\");
		SetCmbItem(IDC_COMBO_PAINTMODE, "g債ĕ\");

		SendMessage(hDlg, WM_SETOPTION, 0, (LPARAM)MainPaintInfo);
		SendMessage(hDlg, WM_GETOPTION, 0, (LPARAM)&op);
		InitPanel(&op);
		SetImegeListIcon(NULL, NULL, op.IconCount / 2 + 1, op.IconSize, &op);
		SetIconPanel(GetDlgItem(hDlg, IDC_BUTTON_VIEW), &op, NULL, 0, 0);
		break;

	case WM_SETOPTION:
		pi = (PAINTINFO *)lParam;
		MoveMemory(&di, &op, sizeof(DRAWINFO));
		MoveMemory(&op, pi, sizeof(PAINTINFO));
		MoveMemory(&op, &di, sizeof(DRAWINFO));

		SendDlgItemMessage(hDlg, IDC_CHECK_WINDEF, BM_SETCHECK, pi->WindowsDef, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_FLAT, BM_SETCHECK, pi->FlatWindow, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_TRANSWINDOW, BM_SETCHECK, pi->TransparentWindow, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_SHOWTITLE, BM_SETCHECK, pi->ShowTitle, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_TITLE_DOWN, BM_SETCHECK, pi->DownTitle, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_TITLE_CENTER, BM_SETCHECK, pi->CenterText, 0);

		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_TITLE_DOWN), pi->ShowTitle);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_TITLE_CENTER), pi->ShowTitle);

		/* Xg{bNX̂PԖڂ̍ڂI */
		SendDlgItemMessage(hDlg, IDC_COMBO_COLOR, CB_SETCURSEL, 0, 0);
		SendMessage(hDlg, WM_SETCOLOR, 0, 0);

		/* tHgޔ */
		lstrcpy(FontInfo.FontName, pi->FontName);
		lstrcpy(FontInfo.FontStyle, pi->FontStyle);
		FontInfo.FontItalic = pi->FontItalic;
		FontInfo.FontHeight = pi->FontHeight;
		FontInfo.FontWeight = pi->FontWeight;
		break;

	case WM_GETOPTION:
		pi = (PAINTINFO *)lParam;
		MoveMemory(&di, pi, sizeof(DRAWINFO));
		MoveMemory(pi, &op, sizeof(PAINTINFO));
		MoveMemory(pi, &di, sizeof(DRAWINFO));

		pi->WindowsDef = SendDlgItemMessage(hDlg, IDC_CHECK_WINDEF, BM_GETCHECK, 0, 0);
		pi->FlatWindow = SendDlgItemMessage(hDlg, IDC_CHECK_FLAT, BM_GETCHECK, 0, 0);
		pi->TransparentWindow = SendDlgItemMessage(hDlg, IDC_CHECK_TRANSWINDOW, BM_GETCHECK, 0, 0);
		pi->ShowTitle = SendDlgItemMessage(hDlg, IDC_CHECK_SHOWTITLE, BM_GETCHECK, 0, 0);
		pi->DownTitle = SendDlgItemMessage(hDlg, IDC_CHECK_TITLE_DOWN, BM_GETCHECK, 0, 0);
		pi->CenterText = SendDlgItemMessage(hDlg, IDC_CHECK_TITLE_CENTER, BM_GETCHECK, 0, 0);

		/* tHg̎擾 */
		lstrcpy(pi->FontName, FontInfo.FontName);
		lstrcpy(pi->FontStyle, FontInfo.FontStyle);
		pi->FontItalic = FontInfo.FontItalic;
		pi->FontHeight = FontInfo.FontHeight;
		pi->FontWeight = FontInfo.FontWeight;
		break;

	case WM_ENABLESWITCH:
		EnableWindow(GetDlgItem(hDlg, IDC_STATIC_BACKGROUND), wParam);
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_BACKGROUND), wParam);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_SELECTFILE), wParam);
		EnableWindow(GetDlgItem(hDlg, IDC_STATIC_POS), wParam);
		EnableWindow(GetDlgItem(hDlg, IDC_COMBO_PAINTMODE), wParam);
		break;

	case WM_SETCOLOR:
		EnableFlag = !SendDlgItemMessage(hDlg, IDC_CHECK_WINDEF, BM_GETCHECK, 0, 0);
		SizeEnable = TRUE;
		ColorEnable = EnableFlag;
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FONT), FALSE);

		/* fUC̐ݒ */
		*fname = '\0';
		size = color = mode = -1;
		switch(SendDlgItemMessage(hDlg, IDC_COMBO_COLOR, CB_GETCURSEL, 0, 0))
		{
		case POS_WINDOW:
			color = op.WindowColor;
			size = op.WindowHeight;
			lstrcpy(fname, op.Background);
			mode = op.BackPaintMode;
			break;

		case POS_FRAME:
			color = op.FrameColor;
			size = op.FrameSize;
			break;

		case POS_TRANSCOLOR:
			color = op.TransparentColor;
			ColorEnable = SendDlgItemMessage(hDlg, IDC_CHECK_TRANSWINDOW, BM_GETCHECK, 0, 0);
			break;

		case POS_ICON:
			size = op.IconSize;
			break;

		case POS_ICONCOUNT:
			size = op.IconCount;
			break;

		case POS_ICONWIDTH:
			size = op.IconWidth;
			break;

		case POS_ICONLEFT:
			size = op.IconLeft;
			break;

		case POS_ICONTOP:
			size = op.IconTop;
			break;

		case POS_SELICON:
			color = op.FocusBackColor;
			size = op.FocusSize;
			lstrcpy(fname, op.FocusBitmap);
			mode = op.FocusPaintMode;
			break;

		case POS_SELICONFRAME:
			color = op.FocusFrameColor;
			size = op.FocusFrameSize;
			break;

		case POS_TITLEBAR:
			color = op.TitleColor;
			size = op.TitleSize;
			lstrcpy(fname, op.Titlebar);
			mode = op.TitlePaintMode;
			break;

		case POS_TITLETEXT:
			color = op.TitleTextColor;
			if(EnableFlag != FALSE){
				EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FONT), TRUE);
			}
			break;

		case POS_TEXTLEFT:
			size = op.TitleTextLeft;
			SizeEnable = (EnableFlag == FALSE) ? FALSE : TRUE;
			break;

		case POS_TEXTRIGHT:
			size = op.TitleTextRight;
			SizeEnable = (EnableFlag == FALSE) ? FALSE : TRUE;
			break;

		case POS_TEXTTOP:
			size = op.TitleTextTop;
			SizeEnable = (EnableFlag == FALSE) ? FALSE : TRUE;
			break;
		}
		/* F */
		EnableWindow(GetDlgItem(hDlg, IDC_STATIC_COLOR),
			(ColorEnable != FALSE && color != -1) ? TRUE : FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COLOR),
			(ColorEnable != FALSE && color != -1) ? TRUE : FALSE);
		wsprintf(buf, "%ld", color);
		SetWindowText(GetDlgItem(hDlg, IDC_BUTTON_COLOR), buf);
		/* TCY */
		EnableWindow(GetDlgItem(hDlg, IDC_STATIC_SIZE), (SizeEnable == TRUE && size != -1) ? TRUE : FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_SIZE), (SizeEnable == TRUE && size != -1) ? TRUE : FALSE);
		if(size != -1){
			SetDlgItemInt(hDlg, IDC_EDIT_SIZE, size, FALSE);
		}else{
			SendDlgItemMessage(hDlg, IDC_EDIT_SIZE, WM_SETTEXT, 0, (LPARAM)"");
		}
		/* 摜 */
		SendMessage(hDlg, WM_ENABLESWITCH, (mode != -1) ? TRUE : FALSE, 0);
		SendDlgItemMessage(hDlg, IDC_EDIT_BACKGROUND, WM_SETTEXT, 0, (LPARAM)fname);
		SendDlgItemMessage(hDlg, IDC_COMBO_PAINTMODE, CB_SETCURSEL, (mode != -1) ? mode : 0, 0);
		InvalidateRect(GetDlgItem(hDlg, IDC_BUTTON_COLOR), NULL, FALSE);
		UpdateWindow(GetDlgItem(hDlg, IDC_BUTTON_COLOR));
		break;

	case WM_GETCOLOR:
		/* F */
		GetWindowText(GetDlgItem(hDlg, IDC_BUTTON_COLOR), buf, BUF_SIZE - 1);
		color = atol(buf);
		/* TCY */
		size = GetDlgItemInt(hDlg, IDC_EDIT_SIZE, NULL, FALSE);
		/* 摜 */
		SendDlgItemMessage(hDlg, IDC_EDIT_BACKGROUND, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)fname);
		mode = SendDlgItemMessage(hDlg, IDC_COMBO_PAINTMODE, CB_GETCURSEL, 0, 0);

		/* fUC̎擾 */
		switch(SendDlgItemMessage(hDlg, IDC_COMBO_COLOR, CB_GETCURSEL, 0, 0))
		{
		case POS_WINDOW:
			op.WindowColor = color;
			op.WindowHeight = size;
			lstrcpy(op.Background, fname);
			op.BackPaintMode = mode;
			break;

		case POS_FRAME:
			op.FrameColor = color;
			op.FrameSize = size;
			break;

		case POS_TRANSCOLOR:
			op.TransparentColor = color;
			break;

		case POS_ICON:
			op.IconSize = size;
			break;

		case POS_ICONCOUNT:
			op.IconCount = (size <= 0) ? 1 : size;
			break;

		case POS_ICONWIDTH:
			op.IconWidth = size;
			break;

		case POS_ICONLEFT:
			op.IconLeft = size;
			break;

		case POS_ICONTOP:
			op.IconTop = size;
			break;

		case POS_SELICON:
			op.FocusBackColor = color;
			op.FocusSize = size;
			lstrcpy(op.FocusBitmap, fname);
			op.FocusPaintMode = mode;
			break;

		case POS_SELICONFRAME:
			op.FocusFrameColor = color;
			op.FocusFrameSize = size;
			break;

		case POS_TITLEBAR:
			op.TitleColor = color;
			op.TitleSize = size;
			lstrcpy(op.Titlebar, fname);
			op.TitlePaintMode = mode;
			break;

		case POS_TITLETEXT:
			op.TitleTextColor = color;
			break;

		case POS_TEXTLEFT:
			op.TitleTextLeft = size;
			break;

		case POS_TEXTRIGHT:
			op.TitleTextRight = size;
			break;

		case POS_TEXTTOP:
			op.TitleTextTop = size;
			break;
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_SETCURSEL, -1, 0);
		SetTimer(hDlg, ID_DRAW_TIMER, DRAW_INTERVAL, NULL);
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, uMsg, wParam, lParam);

	case WM_DRAWITEM:
		dis = (LPDRAWITEMSTRUCT)lParam;
		switch(wParam)
		{
		case IDC_BUTTON_VIEW:
			if(dis->itemState & ODS_SELECTED) break;

			hdc = CreateCompatibleDC(dis->hDC);
			hBmp = CreateCompatibleBitmap(dis->hDC, dis->rcItem.right, dis->rcItem.bottom);
			hrBmp = SelectObject(hdc, hBmp);

			/* wifXNgbv̐FœhԂ */
			hbrush = CreateSolidBrush(GetSysColor(COLOR_DESKTOP));
			FillRect(hdc, &(dis->rcItem), hbrush);
			DeleteObject(hbrush);

			x = op.WindowWidth + op.FrameSize * 2;
			y = op.WindowHeight + op.TitleHeight * op.ShowTitle + op.FrameSize * 2;
			if(op.FlatWindow == 0){
				/* 3Dg̕` */
				rect.left = dis->rcItem.left + PREVIEW_LEFT - 2;
				rect.top = dis->rcItem.top + PREVIEW_TOP - 2;
				rect.right = rect.left + x + 5;
				rect.bottom = rect.top + y + 5;
				DrawFrameControl(hdc, &rect, DFC_BUTTON, DFCS_BUTTONPUSH);
			}

			/* vr[̕` */
			if(op.TransparentWindow == 1){
				/* FL */
				/* EBhEfXNgbv̐FœhԂ */
				rect.left = dis->rcItem.left + PREVIEW_LEFT;
				rect.top = dis->rcItem.top + PREVIEW_TOP;
				rect.right = rect.left + x;
				rect.bottom = rect.top + y;
				hbrush = CreateSolidBrush(GetSysColor(COLOR_DESKTOP));
				FillRect(hdc, &rect, hbrush);
				DeleteObject(hbrush);
				/* ߂ĕ` */
				_TransparentBlt(hdc,
					dis->rcItem.left + PREVIEW_LEFT, dis->rcItem.top + PREVIEW_TOP, x, y,
					op.hPanelDC, dis->rcItem.left, dis->rcItem.top, op.TransparentColor);
			}else{
				BitBlt(hdc,
					dis->rcItem.left + PREVIEW_LEFT, dis->rcItem.top + PREVIEW_TOP,
					x, y,
					op.hPanelDC, dis->rcItem.left, dis->rcItem.top, SRCCOPY);
			}

			BitBlt(dis->hDC,
				dis->rcItem.left, dis->rcItem.top,
				dis->rcItem.right, dis->rcItem.bottom,
				hdc, dis->rcItem.left, dis->rcItem.top, SRCCOPY);

			SelectObject(hdc, hrBmp);
			DeleteObject(hBmp);
			DeleteDC(hdc);
			break;

		default:
			/* g̕` */
			DrawFrameControl(dis->hDC, &(dis->rcItem), DFC_BUTTON,
				DFCS_BUTTONPUSH | ((dis->itemState & ODS_SELECTED) ? DFCS_PUSHED : 0));

			if(dis->itemState & ODS_DISABLED){
				break;
			}

			i = (dis->itemState & ODS_SELECTED) ? 1 : 0;
			dis->rcItem.left += 4 + i;
			dis->rcItem.top += 4 + i;
			dis->rcItem.right -= 5 - i;
			dis->rcItem.bottom -= 5 - i;

			/* F̕` */
			GetWindowText(GetDlgItem(hDlg, wParam), buf, BUF_SIZE - 1);
			color = atol(buf);

			hbrush = CreateSolidBrush(color);
			FillRect(dis->hDC, &(dis->rcItem), hbrush);
			DeleteObject(hbrush);
			FrameRect(dis->hDC, &(dis->rcItem), GetStockObject(BLACK_BRUSH));

			if(dis->itemState & ODS_FOCUS){
				/* tH[JX */
				DrawFocusRect(dis->hDC, &(dis->rcItem));
			}
			break;
		}
		break;

	case WM_TIMER:
		KillTimer(hDlg, wParam);
		SendMessage(hDlg, WM_GETOPTION, 0, (LPARAM)&op);

		/* vr[̍쐬 */
		EndPanel(&op);
		InitPanel(&op);
		SetImegeListIcon(NULL, NULL, op.IconCount / 2 + 1, op.IconSize, &op);
		SetIconPanel(GetDlgItem(hDlg, IDC_BUTTON_VIEW), &op, NULL, 0, 0);
		InvalidateRect(GetDlgItem(hDlg, IDC_BUTTON_VIEW), NULL, FALSE);
		UpdateWindow(GetDlgItem(hDlg, IDC_BUTTON_VIEW));
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		/* ڂ̕ύXꍇ͓o^̑I */
		case IDC_CHECK_WINDEF:
		case IDC_CHECK_FLAT:
		case IDC_CHECK_TRANSWINDOW:
		case IDC_CHECK_SHOWTITLE:
		case IDC_CHECK_TITLE_DOWN:
		case IDC_CHECK_TITLE_CENTER:
			if(HIWORD(wParam) == BN_CLICKED){
				SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_SETCURSEL, -1, 0);
				SetTimer(hDlg, ID_DRAW_TIMER, DRAW_INTERVAL, NULL);
			}
			break;

		case IDC_EDIT_SIZE:
		case IDC_EDIT_BACKGROUND:
			if(HIWORD(wParam) == EN_CHANGE && GetFocus() == GetDlgItem(hDlg, LOWORD(wParam))){
				SendMessage(hDlg, WM_GETCOLOR, 0, 0);
			}
			break;
		}

		switch (LOWORD(wParam))
		{
		case IDC_COMBO_SAVEDATA:
			if(HIWORD(wParam) == CBN_SELCHANGE){
				/* o^Ăݒǂݍ */
				*buf = '\0';
				SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_GETLBTEXT,
					SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_GETCURSEL, 0, 0), (LPARAM)buf);
				if(*buf == '\0'){
					break;
				}
				lstrcpy(rname, buf);
				wsprintf(fname, "%s\\%s.cfg", app_path, buf);
				GetWindowIni(fname, &op);
				SendMessage(hDlg, WM_SETOPTION, 0, (LPARAM)&op);
				SetTimer(hDlg, ID_DRAW_TIMER, DRAW_INTERVAL, NULL);
			}
			break;

		case IDC_BUTTON_REGIST:
			/* ݂̐ݒo^ */
			*buf = '\0';
			SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_GETLBTEXT,
				SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_GETCURSEL, 0, 0), (LPARAM)buf);
			if(*buf == '\0'){
				lstrcpy(buf, rname);
			}
			if(DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_REGIST),
				hDlg, GetRegistProc, (LPARAM)buf) == FALSE){
				break;
			}
			lstrcpy(rname, buf);
			wsprintf(fname, "%s\\%s.cfg", app_path, buf);
			SendMessage(hDlg, WM_GETOPTION, 0, (LPARAM)&op);
			PutWindowIni(fname, &op);

			i = SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_FINDSTRING, -1, (LPARAM)buf);
			if(i < 0){
				i = SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_ADDSTRING, 0, (LPARAM)buf);
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_SETCURSEL, i, 0);
			break;

		case IDC_BUTTON_DELETE:
			/* ݂̐ݒ폜 */
			*buf = '\0';
			SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_GETLBTEXT,
				SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_GETCURSEL, 0, 0), (LPARAM)buf);
			if(*buf == '\0'){
				break;
			}
			if(MessageBox(hDlg, "폜Ă낵łH", "폜", MB_ICONQUESTION | MB_YESNO) == IDNO){
				break;
			}
			wsprintf(fname, "%s\\%s.cfg", app_path, buf);
			DelWindowIni(fname);
			SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_DELETESTRING,
				SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_GETCURSEL, 0, 0), 0);
			SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_SETCURSEL, -1, 0);
			break;

		case IDC_CHECK_WINDEF:
		case IDC_CHECK_TRANSWINDOW:
			SendMessage(hDlg, WM_SETCOLOR, 0, 0);
			break;

		case IDC_CHECK_SHOWTITLE:
			/* t[ݒ̏ԕύX */
			EnableFlag = SendDlgItemMessage(hDlg, IDC_CHECK_SHOWTITLE, BM_GETCHECK, 0, 0);
			EnableWindow(GetDlgItem(hDlg, IDC_CHECK_TITLE_DOWN), EnableFlag);
			EnableWindow(GetDlgItem(hDlg, IDC_CHECK_TITLE_CENTER), EnableFlag);
			break;

		case IDC_BUTTON_VIEW:
			SendMessage(hDlg, WM_GETOPTION, 0, (LPARAM)&op);

			/* ꏊ̎擾 */
			GetCursorPos(&ps);
			GetWindowRect(GetDlgItem(hDlg, IDC_BUTTON_VIEW), &rect);

			if(GetKeyState(VK_SHIFT) & 0x8000){
				/* ̐Fݒ */
				hdc = GetDC(GetDlgItem(hDlg, IDC_BUTTON_VIEW));
				wsprintf(buf, "%ld", GetPixel(hdc, ps.x - rect.left, ps.y - rect.top));
				ReleaseDC(GetDlgItem(hDlg, IDC_BUTTON_VIEW), hdc);
				SetWindowText(GetDlgItem(hDlg, IDC_BUTTON_COLOR), buf);
				InvalidateRect(GetDlgItem(hDlg, IDC_BUTTON_COLOR), NULL, FALSE);
				UpdateWindow(GetDlgItem(hDlg, IDC_BUTTON_COLOR));
				SendMessage(hDlg, WM_GETCOLOR, 0, 0);
				break;
			}

			/* ^Cgo[̍擾 */
			op.TitleHeight = GetTitleSize(&op);
			/* NbNꂽꏊ擾 */
			i = PanelHitTest(&op, ps.x - (rect.left + PREVIEW_LEFT), ps.y - (rect.top + PREVIEW_TOP), 0);
			if(i > POS_ICONINDEX) i = POS_ICON;
			if(i == POS_ICONINDEX) i = POS_WINDOW;

			/* ꏊɑΉ閼OI */
			SendDlgItemMessage(hDlg, IDC_COMBO_COLOR, CB_SETCURSEL, i, 0);
			SendMessage(hDlg, WM_SETCOLOR, 0, 0);
			break;

		case IDC_COMBO_COLOR:
			/* FI{^̕\ύX */
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_SETCOLOR, 0, 0);
			}
			break;

		case IDC_BUTTON_COLOR:
			GetWindowText(GetDlgItem(hDlg, IDC_BUTTON_COLOR), buf, BUF_SIZE - 1);
			color = atol(buf);

			/* F̑I */
			color = GetColor(hDlg, color);
			if(color == atol(buf)){
				break;
			}
			wsprintf(buf, "%ld", color);
			SetWindowText(GetDlgItem(hDlg, IDC_BUTTON_COLOR), buf);

			InvalidateRect(GetDlgItem(hDlg, IDC_BUTTON_COLOR), NULL, FALSE);
			UpdateWindow(GetDlgItem(hDlg, IDC_BUTTON_COLOR));

			SendMessage(hDlg, WM_GETCOLOR, 0, 0);
			break;

		case IDC_BUTTON_FONT:
			/* tHg̑I */
			if(GetFontInfo(hDlg, &FontInfo) == TRUE){
				SendDlgItemMessage(hDlg, IDC_COMBO_SAVEDATA, CB_SETCURSEL, -1, 0);
				SetTimer(hDlg, ID_DRAW_TIMER, DRAW_INTERVAL, NULL);
			}
			break;

		case IDC_BUTTON_SELECTFILE:
			/* wit@C̑I */
			if(FileSelect(hDlg, buf) != -1){
				SendDlgItemMessage(hDlg, IDC_EDIT_BACKGROUND, WM_SETTEXT, 0, (LPARAM)buf);
				SendMessage(hDlg, WM_GETCOLOR, 0, 0);
			}
			break;

		case IDC_COMBO_PAINTMODE:
			/* 摜̈ʒu̎w */
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_GETCOLOR, 0, 0);
			}
			break;

		case IDOK:
			SendMessage(hDlg, WM_GETOPTION, 0, (LPARAM)MainPaintInfo);
			EndPanel(&op);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndPanel(&op);
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SetOption

	ݒʂ̕\

******************************************************************************/

BOOL SetOption(const HWND hWnd, PAINTINFO *pi)
{
#define sizeof_PROPSHEETHEADER		40	//ÂRRg[΍
	PROPSHEETPAGE psp;
	PROPSHEETHEADER psh;
	HPROPSHEETPAGE hpsp[2];

	MainPaintInfo = pi;

	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	psp.hInstance = hInst;

	/* ݒ */
#ifdef NONAMELESSUNION
	psp.DUMMYUNIONNAME.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_OPTION);
#else
	psp.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_OPTION);
#endif
	psp.pfnDlgProc = SetOptionProc;
	hpsp[0] = CreatePropertySheetPage(&psp);

	/* \ݒ */
#ifdef NONAMELESSUNION
	psp.DUMMYUNIONNAME.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_OPTION_WINDOW);
#else
	psp.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_OPTION_WINDOW);
#endif
	psp.pfnDlgProc = SetWindowOptionProc;
	hpsp[1] = CreatePropertySheetPage(&psp);

	ZeroMemory(&psh, sizeof(PROPSHEETHEADER));
	psh.dwSize = sizeof_PROPSHEETHEADER;
	psh.dwFlags = PSH_NOAPPLYNOW;
	psh.hwndParent = hWnd;
	psh.hInstance = hInst;
	psh.pszCaption = OPTION_TITLE;
	psh.nPages = sizeof(hpsp) / sizeof(HPROPSHEETPAGE);
#ifdef NONAMELESSUNION
	psh.DUMMYUNIONNAME3.phpage = hpsp;
	psh.DUMMYUNIONNAME2.nStartPage = 0;
#else
	psh.phpage = hpsp;
	psh.nStartPage = 0;
#endif

	PropRet = FALSE;
	PropertySheet(&psh);
	return PropRet;
}
/* End of source */
